﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Collections.ObjectModel;

namespace DisplayASimpleMapDesktop
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;

            ShapeFileFeatureLayer shapeFileFeatureLayer = new ShapeFileFeatureLayer(@"..\..\Export_Strassen.shp",ShapeFileReadWriteMode.ReadWrite);
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Interstate4;
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(shapeFileFeatureLayer);

            winformsMap1.Overlays.Add(overlay);

            shapeFileFeatureLayer.Open();
            winformsMap1.CurrentExtent = shapeFileFeatureLayer.GetBoundingBox();
            winformsMap1.Refresh();
        }

        private void button1_Click(object sender, EventArgs e)
        {
        }

        private void winformsMap1_MapClick(object sender, MapClickWinformsMapEventArgs e)
        {
            ShapeFileFeatureLayer shapeFileFeatureLayer = (winformsMap1.Overlays[0] as LayerOverlay).Layers[0] as ShapeFileFeatureLayer;
            shapeFileFeatureLayer.Open();
            Collection<Feature> nearestFeature = shapeFileFeatureLayer.QueryTools.GetFeaturesNearestTo(e.WorldLocation, GeographyUnit.Meter, 1, ReturningColumnsType.NoColumns);

            if (nearestFeature.Any())
            {
                shapeFileFeatureLayer.FeatureSource.BeginTransaction();
                shapeFileFeatureLayer.FeatureSource.DeleteFeature(nearestFeature[0].Id);
                shapeFileFeatureLayer.FeatureSource.CommitTransaction();
            }
            winformsMap1.Refresh();
        }
    }
}
